#!/usr/local/bin/perl

##### Edit these Variables to fit your Needs!
my @DBs = ("3xUrls.db","3xClans.db","3xServer.db","3xEmails.db","3xIcq.db","3xWhat.db","3xCountries.db");
my $pathDBs = "/home/m/mrbrain/EggDrop/data/"; # needs trailing Slash!

my $buffer, $value, $pair, $name, $ARGS;
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
my @pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
  ($name, $value) = split(/=/, $pair);
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $value =~ s/\\/\//g;
  $ARGS{$name} = $value;
}

$buffer=$ENV{'QUERY_STRING'};
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
  ($name, $value) = split(/=/, $pair);
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $value =~ s/\\/\//g;
  $ARGS{$name} = $value;
}

if ($ARGS{'db'} eq "") { $ARGS{'db'} = $DBs[0]; }
if (!open(FILE,"$pathDBs$ARGS{'db'}")) { exit; }
my @allEntries = <FILE>;
close(FILE);

@allEntries = sort { uc($b) cmp uc($a) } @allEntries;

print "Content-type: text/html\n\n";
print "<HTML><HEAD><TITLE>3xBot - Databases</TITLE></HEAD><BODY BGCOLOR=#FFFFFF TEXT=#000000 LINK=#FF0000 ALINK=#FF0000 VLINK=#FF0000>\n";

print "<CENTER>\n";
print "<FORM ACTION=\"db.cgi\" METHOD=GET>\n";
print "<SELECT NAME=\"db\">\n";
my $n;
for ($n=0; $n<@DBs; $n++) {
  print " <OPTION ";
  if ($DBs[$n] eq $ARGS{'db'}) { print "SELECTED "; }
  print "VALUE=\"$DBs[$n]\">$DBs[$n]</OPTION>\n";
}
print "</SELECT>\n";
print "<INPUT TYPE=SUBMIT>\n";
print "</FORM>\n";
$n = @allEntries;
print "Covering $n Entries!<BR><BR>\n";
print "</CENTER>\n";

my $i,$aEntry;
for ($i=@allEntries; $i>0; $i--) {
  $aEntry = $allEntries[$i];
  $aEntry =~ s/[\r\n]//g;
  if ($aEntry eq "") { next; }
  $aEntry =~ s/^(.*)(http:\/\/.*)$/\1 \<A HREF=\"\2\" TARGET=\"_blank\">\2/;
  print "<TABLE WIDTH=100% BORDER=0 CELLSPACING=0 CELLPADDING=5><TR><TD BGCOLOR=#EEEEEE>\n";
  print "$aEntry\n";
  print "</TD></TR></TABLE>\n";
  print "<BR>\n";
}

print "</BODY></HTML>\n";
