#vShit.tcl, by vman (vman@x3d.net)
#
#this script is a modified version of "vrpack v1.6.0 Beta".  some small procs have been held
#from that package in addition to new ones.  this is an old, old script that i don't bother
#making efficient, so do not expect anything fancy :)  grab the portions you need.
#
#tested on eggdrop v1.4.1
#
set revision "02/02/2000"
###   CONFIGURATION   #########################################################################
set sitename "BLA";				#hrm? :)
set pubchans1 "#chan1 #chan2"			;#for newdirs/nukes/unnukes/winners
set pubchans2 "#chan1 #chan3"			;#for freespace/bandwidth/deldirs
set no_onjoin "#chan2"				;#bla
set cmdpre "!xx"				;#prefix (!xxhelp, !xxstats, !xxbw)
set chktimer 5					;#read logfile every chktimer seconds
set gllog "/glftpd/ftp-data/logs/glftpd.log"	;#/path/to/glftpd.log
set glftpdbin "/glftpd/bin"			;#/path/to/bin_dir
set block_size 1				;#the dominant block-size in `df -k'
				#do not post as newdir/winners.  you can also use this as an
				#alternative to the `dirlog' in glftpd.conf
set deny_post {
  *demo*
  *sample*
  *cover*
  *kbps*
}

				#this is for the df command.  drives to show free space for
set devices {
  /dev/hda2
  /dev/md0
}

				#name the devices above accordingly
set sections {
  incoming
  archive
}
###############################################################################################








#this sets the bw and df commands on a timer.  change it around by looking at the `timed' proc.
#bind time -|- "00 * * * *" timed
bind pub -|- [set cmdpre]bw bw
#custom
#bind pub -|- [set cmdpre]bwt bwt
bind pub -|- [set cmdpre]df df
bind pub -|- [set cmdpre]stats stats
bind pub -|- [set cmdpre]inc inc
bind pub -|- [set cmdpre]pinc pinc
bind pub -|- [set cmdpre]help help
bind pub -|- [set cmdpre]shelp stats_help
bind pub -|- [set cmdpre]who who
bind join -|- * auto_notice


proc timed {min hour day month year} {  global pubchans2
  post_bandwidth $pubchans2
  post_diskspace $pubchans2
  return 0
}


proc auto_notice {nick uhost hand chan} {  global cmdpre sitename no_onjoin
  if {[lsearch [string tolower $no_onjoin] [string tolower $chan]] != -1} {return 0}
  putserv "NOTICE $nick :\[[b]$sitename[b]\] ..welcome.. type [b][set cmdpre]help[b] for assistance"
}


proc who {nick uhost hand chan args} {
  global glftpdbin
  set msg [split [exec -- $glftpdbin/who bla bla bla] "\n"]
  foreach line $msg {
	putserv "PRIVMSG $nick :$line"
  }
  return 0
}


proc scanlog {} {  global sitename gllog pubchans1 chktimer lastoct deny_post
  utimer $chktimer "scanlog"
  if {[file size $gllog] == $lastoct} {return 0}
  if {[file size $gllog] < $lastoct} {set lastoct 0}
  if {[catch {set of [open $gllog r]}] != 0} {return 0}
  seek $of $lastoct
  while {![eof $of]} {
    set line [gets $of]
    if {$line == ""} {continue}
    if {[catch {set date [clock scan [lrange $line 0 4]]}] != 0} {continue}
    set type [lindex $line 5]
    set args [lrange $line 6 end]
    switch $type {
      NEWDIR: {
     #NEWDIR: <path> <user> <user_grp> <user_tag>
	foreach skip $deny_post {
		if {[string match "$skip" [string tolower [lindex $args 0]]]} {
			close $of ; snop ; set lastoct [file size $gllog] ; return 0
		}
        }
        set pf [rel [lindex $args 0]]
        if {$pf == 0} {continue}
        set path [lindex $pf 0]
        set rel [lindex $pf 1]
        if {[lindex $args 2] == ""} {set group "\$NULL"}
	sndall "( [b]$sitename[b] ) .:NEW:. /$path/[b]$rel[b] - ([lindex $args 1]@[lindex $args 2] : [lindex $args 3])"
      }

      RACE: {
     #RACE: <path> <user_winner> <user_grp> <user_amount> <user_files> <grp_winner> <grp_amount> <grp_files> <total_amount> <total_files> <total_duration> <total_user_racres> <total_group_racers>
	foreach skip $deny_post {
		if {[string match "$skip" [string tolower [lindex $args 0]]]} {
			close $of ; snop ; set lastoct [file size $gllog] ; return 0
		}
        }
        set pf [rel [lindex $args 0]]
        set path [lindex $pf 0]
        set rel [lindex $pf 1]
        if {[lindex $args 10] == 0} {
          set duration ""
        } else {
          set duration ", [format "%.2f" "[expr [lindex $args 10] / 60.0]"] minutes"
	}
	sndall "( [b]$sitename[b] ) .:WINNERS:. [b]$rel[b] - (user:  [b][lindex $args 1]@[lindex $args 2][b] of [lindex $args 11] racers, [lindex $args 4] files at [format "%.0f" [expr [lindex $args 3] / 1024]]MB) - (group:  [b][lindex $args 5][b] of [lindex $args 12] racers, [lindex $args 7] files at [format "%.0f" [expr [lindex $args 6] / 1024]]MB) - \[total:  [lindex $args 9] files at [format "%.0f" [expr [lindex $args 8] / 1024]]MB$duration\]"
      }

	SFV: {
       #SFV: <path> <total_files> <base_file>
		set pf [rel [lindex $args 0]]
		set path [lindex $pf 0]
		set rel [lindex $pf 1]
		sndall "( [b]$sitename[b] ) .:EXPECTED FILES:. /$path/[b]$rel[b] - (files:  [lindex $args 1] -> [lindex $args 2].\*)"
	}

	ZIP: {
       #ZIP: <path> <total_files> <base_file> <expected_size>	
		set pf [rel [lindex $args 0]]
		set path [lindex $pf 0]
		set rel [lindex $pf 1]
		sndall "( [b]$sitename[b] ) .:EXPECTED FILES:. /$path/[b]$rel[b] - (files:  [lindex $args 1] -> [lindex $args 2].\*) - (size estimate: [format "%.2f" [lindex $args 3]]KB)"
	}

      COMPLETENESS_STATUS: {
     #COMPLETENESS_STATUS: <amount_missing>
        if {[lindex $args 0] > 0} {
	  sndall "( [b]$sitename[b] ) .:INCOMPLETE:. (use \"SITE INC\" to view the list) - (missing:  [lindex $args 0] cds)"
        }
      }

      PRE: {
     #PRE: <path> <grp_tag> <size> <files>
        set pf [rel [lindex $args 0]]
        set path [lindex $pf 0]
        set rel [lindex $pf 1]
	sndall "( [b]$sitename[b] ) -->PRE<-- [b]$rel[b] - (group:  [lindex $args 1], [lindex $args 3] files at [format "%.2fMB" "[lindex $args 2]"])"
      }

      NUKE: {
     #NUKE: "/site/VCDS/Chinese.Erotic.Ghost.Story.XXX-KFK" "nuker" "nukee" "1 530.8" "NO SAMPLE"
        newnuke NUKE [lindex [rel [lindex $args 0]] 1] $args
      }

      UNNUKE: {
     #UNNUKE: "/site/VCDS/Universal.Soldier.The.Return.Vcd.ts-TECiSO" "unnuker" "unnukee" "1 390.6" "reason"
        newnuke UNNUKE [lindex [rel [lindex $args 0]] 1] $args
      }

	DELETED: {
	#DELETED: <dir> <size in kb>

	#add the following line in barkeep's autodel script, just before it does `rm -fr'
	#echo `date +"%a %b %d %T %Y"` DELETED: "$OLDUP" `du -s $uploads/$OLDUP | awk '{print $1}'` >> /glftpd/ftp-data/logs/glftpd.log

	  sndall "( [b]$sitename[b] ) .:AUTO DELETE:. [b][lindex $args 0][b] - (freed:  [b][lindex $args 1]KB[b])"
	}

      DELDIR: {
     #DELDIR: "/site/VCDS/Slut_Woman-XXX-DVNVCD" "user" "GRP" "tagline"
        #nothing for now :)
      }
    }
  }
  close $of
  snop
  set lastoct [file size $gllog]
  return 0
}


proc newnuke {type dir args} {global cnuke lasttype lastdir
  set args [lindex $args 0]
  if {$type == $lasttype && $dir == $lastdir && $cnuke(shown) == 0} {
    append cnuke(nukee) "[lindex $args 2] ([lindex [lindex $args 3] 1]MB), "
  } else {
    snop
    set cnuke(type) $type
    set cnuke(dir) $dir
    set cnuke(nuker) [lindex $args 1]
    set cnuke(nukee) "[lindex $args 2] ([lindex [lindex $args 3] 1]MB)"
    set cnuke(mult) [lindex [lindex $args 3] 0]
    set cnuke(reason) [lindex $args 4]
    set cnuke(shown) 0
  }
  set lasttype $type
  set lastdir $dir
}


proc snop {} {  global cnuke sitename pubchans1
  if {$cnuke(shown) == 1} {return 0}
  set cnuke(nukee) [string trim $cnuke(nukee) ", "]
  sndall "( [b]$sitename[b] ) .:$cnuke(type) $cnuke(mult)x:. [b]$cnuke(dir)[b] - (nuker: [b]$cnuke(nuker)[b], nukees: $cnuke(nukee), reason: $cnuke(reason))"
  set cnuke(shown) 1
}


proc bw {nick uhost hand chan args} {  global pubchans2
  if {[lsearch [string tolower $pubchans2] [string tolower $chan]] == -1} {return 0}
  post_bandwidth $chan
  return 0
}


proc df {nick uhost hand chan args} {  global pubchans2
  if {[lsearch [string tolower $pubchans2] [string tolower $chan]] == -1} {return 0}
  post_diskspace $chan
  return 0
}


proc post_bandwidth {channels} {  global glftpdbin sitename
  #up_users , down_users , idle , up_speed , down_speed
  set speed [exec -- $glftpdbin/who bla bla quick]

  foreach chan $channels {
	putserv "PRIVMSG $chan :( [b]$sitename[b] ) .:BANDWIDTH:. (uL:[lindex $speed 0] at [b][lindex $speed 3]kB/s[b]) - (dL:[lindex $speed 1] at [b][lindex $speed 4]kB/s[b]) - \[total:[expr [lindex $speed 0] + [lindex $speed 1]] at [b][expr [lindex $speed 3] + [lindex $speed 4]]kB/s[b]\]"
  }

  return 0
}


#custom, 2 daemons
proc bwt {nick uhost hand chan args} {  global glftpdbin
  set chans "#chan1 #chan2";		#channels allowed to use it

  if {[lsearch $chans $chan] == -1} {return 0}
  #up_users , down_users , idle , up_speed , down_speed
  set speed1 [exec -- $glftpdbin/speed1 bla bla quick]
  set speed2 [exec -- $glftpdbin/speed2 bla bla quick]
  set speed3 "[expr [lindex $speed1 0] + [lindex $speed2 0]] [expr [lindex $speed1 1] + [lindex $speed2 1]] [expr [lindex $speed1 2] + [lindex $speed2 2]] [expr [lindex $speed1 3] + [lindex $speed2 3]] [expr [lindex $speed1 4] + [lindex $speed2 4]]"

  putserv "PRIVMSG $chan :( [b]\*SiteA\+SiteB\*[b] ) .:BANDWIDTH:. (uL:[lindex $speed3 0] at [b][lindex $speed3 3]kB/s[b]) - (dL:[lindex $speed3 1] at [b][lindex $speed3 4]kB/s[b]) - \[total:[expr [lindex $speed3 0] + [lindex $speed3 1]] at [b][expr [lindex $speed1 3] + [lindex $speed1 4] + [lindex $speed2 3] + [lindex $speed2 4]]kB/s[b]\]"
  return 0
}


proc post_diskspace {channels} {  global devices sections sitename block_size
  set data [lrange [split [exec /bin/df -k] "\n"] 1 end]
  set message "( [b]$sitename[b] ) .:FREE SPACE:."
  set total 0

  foreach line $data {
	set valid_dev [lsearch $devices [lindex $line 0]]
	if {$valid_dev != -1} {
		set total [expr $total + ([lindex $line 3] / 1024.0) * $block_size]
		append message " ([lindex $sections $valid_dev]: [b][expr ([lindex $line 3] / 1024) * $block_size]MB[b]) -"
	}
  }

  if {$total > 1024} {
	set total "[format "%.2f" "[expr $total / 1024.0]"]GB"
  } else {
	set total "[format "%.2f" "$total"]MB"
  }

  append message " \[total:  [b]$total[b]\]"
  foreach chan $channels {putserv "PRIVMSG $chan :$message"}

  return 0
}


proc stats {nick uhost hand chan args} {  global glftpdbin lastbind cmdpre
  set args [lindex $args 0]
  if {[llength $args] < 2} {putserv "PRIVMSG $chan :nothing personal, but you need [set cmdpre]help :)" ; return 0}
  if {[lindex $args 2] == ""} {lappend $args 0}	
  if {[lindex $args 3] == ""} {lappend $args 10}

  switch -- [lindex $args 0] {
	-u {
		switch -- [lindex $args 1] {
			-(t|w|m {set stats [split [exec -- $glftpdbin/stats [lindex $args 0] [lindex $args 1] -s[lindex $args 2] -x[lindex $args 3]] "\n"]}
			-w {set stats [split [exec -- $glftpdbin/stats [lindex $args 0] [lindex $args 1] -s[lindex $args 2] -x[lindex $args 3]] "\n"]}
			-m {set stats [split [exec -- $glftpdbin/stats [lindex $args 0] [lindex $args 1] -s[lindex $args 2] -x[lindex $args 3]] "\n"]}
			-a {set stats [split [exec -- $glftpdbin/stats [lindex $args 0] [lindex $args 1] -s[lindex $args 2] -x[lindex $args 3]] "\n"]}
			-W {set stats [split [exec -- $glftpdbin/stats [lindex $args 0] [lindex $args 1] -s[lindex $args 2] -x[lindex $args 3]] "\n"]}
			-A {set stats [split [exec -- $glftpdbin/stats [lindex $args 0] [lindex $args 1] -s[lindex $args 2] -x[lindex $args 3]] "\n"]}
			-n {set stats [split [exec -- $glftpdbin/stats [lindex $args 0] [lindex $args 1] -s[lindex $args 2] -x[lindex $args 3]] "\n"]}
			default {putserv "PRIVMSG $chan :nothing personal, but you need [set cmdpre]help :)" ; return 0}
		}

	}

	-d {
		switch -- [lindex $args 1] {
			-t {set stats [split [exec -- $glftpdbin/stats [lindex $args 0] [lindex $args 1] -s[lindex $args 2] -x[lindex $args 3]] "\n"]}
			-w {set stats [split [exec -- $glftpdbin/stats [lindex $args 0] [lindex $args 1] -s[lindex $args 2] -x[lindex $args 3]] "\n"]}
			-m {set stats [split [exec -- $glftpdbin/stats [lindex $args 0] [lindex $args 1] -s[lindex $args 2] -x[lindex $args 3]] "\n"]}
			-a {set stats [split [exec -- $glftpdbin/stats [lindex $args 0] [lindex $args 1] -s[lindex $args 2] -x[lindex $args 3]] "\n"]}
			-W {set stats [split [exec -- $glftpdbin/stats [lindex $args 0] [lindex $args 1] -s[lindex $args 2] -x[lindex $args 3]] "\n"]}
			-A {set stats [split [exec -- $glftpdbin/stats [lindex $args 0] [lindex $args 1] -s[lindex $args 2] -x[lindex $args 3]] "\n"]}
			-n {set stats [split [exec -- $glftpdbin/stats [lindex $args 0] [lindex $args 1] -s[lindex $args 2] -x[lindex $args 3]] "\n"]}
			default {putserv "PRIVMSG $chan :nothing personal, but you need [set cmdpre]help :)" ; return 0}
		}
	}

	default {putserv "PRIVMSG $chan :nothing personal, but you need [set cmdpre]help :)" ; return 0}
  }

  foreach currline $stats {putserv "PRIVMSG $nick :$currline"}

  return 0
}


proc inc {nick uhost hand chan args} {  global incfile
  if {![file exist $incfile]} {putlog "incomplete file not found!" ; return 0}
  dccsend $incfile $nick
  return 0
}


proc pinc {nick uhost hand chan args} {  global incfile
  if {![file exist $incfile]} {putlog "incomplete file not found!" ; return 0}
  set of [open $incfile r]

  while {![eof $of]} {
	set currline [gets $of]
	if {$currline == "" || [string match "  \**" $currline]} {continue}
	putserv "PRIVMSG $nick :$currline"
  }

  close $of
  return 0
}


proc help {nick uhost hand chan args} {  global lastbind cmdpre
  putserv "PRIVMSG $nick :...:( .H.E.L.P. ):..."
  putserv "PRIVMSG $nick :[set cmdpre]bw     - bandwidth usage"
#custom
#  putserv "PRIVMSG $nick :[set cmdpre]bwt    - total bandwidth usage"
  putserv "PRIVMSG $nick :[set cmdpre]df     - disk space usage"
  putserv "PRIVMSG $nick :[set cmdpre]inc    - dcc send incomplete list (missing files)"
  putserv "PRIVMSG $nick :[set cmdpre]pinc   - msg incomplete list (missing files)"
  putserv "PRIVMSG $nick :[set cmdpre]stats  - stats (alltime/month/week/day, etc.)"
  putserv "PRIVMSG $nick :[set cmdpre]shelp  - help menu for [set cmdpre]stats"
  return 0
}


proc stats_help {nick uhost hand chan args} {  global cmdpre
  putserv "PRIVMSG $nick :SYNTAX ->  [set cmdpre]stats \[?arg1\] \[?arg2\] (\[?arg3\]) (\[?arg4\])"
  putserv "PRIVMSG $nick : "
  putserv "PRIVMSG $nick :OPTIONS:"
  putserv "PRIVMSG $nick :..arg1: -[u]u[u]pload -[u]d[u]ownload"
  putserv "PRIVMSG $nick :..arg2: -[u]t[u]oday -[u]w[u]eek -[u]m[u]onth -[u]a[u]ll -[u]W[u]eekGRP -[u]A[u]llGRP -[u]n[u]uked"
  putserv "PRIVMSG $nick :..arg3: [u]0[u]=ISO, [u]1[u]=REQUESTS (default=0)"
  putserv "PRIVMSG $nick :..arg4: list arg4 many users (default=10)"
  putserv "PRIVMSG $nick : "
  putserv "PRIVMSG $nick :example ->  [set cmdpre]stats -u -W 0 5"
  putserv "PRIVMSG $nick :example ->  [set cmdpre]stats -u -A"
  return 0
}


###   HELPER PROCS   ##########################################################################
proc sndall {args} {  global pubchans1
  foreach chan $pubchans1 {putserv "PRIVMSG $chan :[lindex $args 0]"}
}


proc rel {fpath} {
  set split [split $fpath "/"]
  set ll [llength $split]
  if {$ll < 3} {return "\{ERR\} \{ERR\}"}
  set loc "[lindex $split [expr $ll - 2]]"
  set rel "[lindex $split [expr $ll - 1]]"
  if {[string match "\[cC\]\[dD\]\[0-9\]" $rel] || [string match "\[dD\]\[iI\]\[sS\]\[cCkK\]*" $rel] || [string match "\[pP\]\[aA\]\[rR\]\[tT\]*" $rel]} {
	set loc "[lindex $split [expr $ll - 3]]"
	set rel "[lindex $split [expr $ll - 2]]/$rel"
  }
  return "\{$loc\} \{$rel\}"
}


proc fixlenc {txt len char} {while {[string length $txt] < $len} {append txt $char} ; return $txt}
proc fixlenf {txt len} {while {[string length $txt] < $len} {set txt " $txt"} ; return $txt}
proc u {} {return \037};	#underline
proc r {} {return \026};	#reverse
proc c {} {return \003};	#color
proc b {} {return \002};	#bold
proc a {} {return \001};	#???
###############################################################################################


if {[lsearch [utimers] "* scanlog *"] == -1} {utimer $chktimer "scanlog"}
if {![array exists cnuke]} {set cnuke(dir) new ; set cnuke(type) new ;set cnuke(shown) 1 ; set lasttype "" ; set lastdir ""}
if {![info exists lastoct]} {set lastoct [file size $gllog]}




putlog "->  vShit.tcl (vman) \*$revision\*"
